﻿using SimpleJSON;
using System;
using System.Collections.Generic;
using System.Linq;
using ToySerialController.UI;
using ToySerialController.Utils;
using UnityEngine;
using DebugUtils;

namespace ToySerialController.MotionSource
{
    public class MaleFemaleMotionSource : AbstractFemaleMotionSource
    {
        private float _penisLength;
        private float _penisRadius;
        private Transform _penisOrigin;
        private Vector3 _planeNormal;
        private Vector3 _referencePosition;

        private int _penisLengthAverageIndex = 0;
        private float[] _penisLengthAverages = null;
        private const int PENIS_LENGTH_AVERAGES_COUNT = 60;

        private Atom _maleAtom;

        private JSONStorableStringChooser MaleChooser;
        private JSONStorableBool MaleUsePenisFixedLengthReference;
        private JSONStorableFloat MalePenisFixedLengthReference;

        private SuperController Controller => SuperController.singleton;

        public override Vector3 ReferencePosition => _referencePosition;
        public override Vector3 ReferenceUp => (_penisOrigin != null ? _penisOrigin.up : Vector3.up);
        public override Vector3 ReferenceRight => -(_penisOrigin != null ? _penisOrigin.forward : Vector3.forward);
        public override Vector3 ReferenceForward => (_penisOrigin != null ? _penisOrigin.right : Vector3.right);
        public override float ReferenceLength => _penisLength;
        public override float ReferenceRadius => _penisRadius;
        
        public override Vector3 ReferencePlaneNormal => _planeNormal;

        public override void CreateUI(IUIBuilder builder)
        {
            MaleChooser = builder.CreatePopup("MotionSource:Male", "Select Male", null, null, MaleChooserCallback);
            MaleUsePenisFixedLengthReference = builder.CreateToggle("MotionSource:MaleUseFixedPensisLength", "Use Fixed Penis Reference Length", false);
            MalePenisFixedLengthReference = builder.CreateSlider("MotionSource:MaleFixedPensigLength", "Penis Reference Length", 152f, 20.0f, 500.0f, true, true);

            FindMales();

            base.CreateUI(builder);
        }

        public override void DestroyUI(IUIBuilder builder)
        {
            builder.Destroy(MaleChooser);
            builder.Destroy(MaleUsePenisFixedLengthReference);
            builder.Destroy(MalePenisFixedLengthReference);

            base.DestroyUI(builder);
        }

        public override bool Update(Func<IMotionSource, bool> test) => UpdateMale() && base.Update(test);

        private bool UpdateMale()
        {
            if (_maleAtom == null)
                return false;

            var penisColliders = new List<string> {
                "AutoColliderGen1Hard",
                "AutoColliderGen2Hard",
                "AutoColliderGen3aHard",
                "AutoColliderGen3bHard"
            };

            var penisTransforms = _maleAtom
                .GetComponentsInChildren<Collider>()
                .Where(c => penisColliders.Contains(c.name))
                .OrderBy(c => c.name, StringComparer.OrdinalIgnoreCase)
                .Select(c => c.transform)
                .ToList();

            if (penisTransforms.Count != 4)
                return false;

            _penisLength = 0.0f;
            for (int i = 0, j = 1; j < penisTransforms.Count; i = j++)
                _penisLength += Vector3.Distance(penisTransforms[i].position, penisTransforms[j].position);

            _penisOrigin = penisTransforms[0];

            var positionOffset = -_penisOrigin.up * (penisTransforms[1].position - penisTransforms[0].position).magnitude * 0.15f;
            _referencePosition = _penisOrigin.position + positionOffset + Vector3.Normalize(positionOffset) * 0.015f;
            _penisLength += positionOffset.magnitude;
            _penisLength += penisTransforms[3].GetComponent<CapsuleCollider>().radius;
            _penisLength += 0.015f;
            _penisRadius = Math.Max(penisTransforms[1].GetComponent<CapsuleCollider>().radius, 0.016f);

            if (MaleUsePenisFixedLengthReference.val)
                _penisLength = MalePenisFixedLengthReference.val / 1000f;
            else
            {
                _penisLength = RecordPenisAverage(_penisLength);
                MalePenisFixedLengthReference.val = _penisLength * 1000f;
            }

            var pelvisRight = _maleAtom.GetComponentByName<Collider>("AutoColliderpelvisFR3Joint")?.transform;
            var pelvidLeft = _maleAtom.GetComponentByName<Collider>("AutoColliderpelvisFL3Joint")?.transform;
            var pelvisMid = _maleAtom.GetComponentByName<Transform>("AutoColliderpelvisF1")?.GetComponentByName<Collider>("AutoColliderpelvisF4Joint")?.transform;

            if (pelvisRight == null || pelvidLeft == null || pelvisMid == null)
                _planeNormal = _penisOrigin.up;
            else
                _planeNormal = Vector3.Cross(pelvisMid.position - pelvidLeft.position, pelvisMid.position - pelvisRight.position).normalized;

            DebugDraw.DrawSquare(ReferencePosition, ReferencePlaneNormal, ReferenceRight, Color.white, 0.33f);
            DebugDraw.DrawTransform(ReferencePosition, ReferenceUp, ReferenceRight, ReferenceForward, 0.15f);
            DebugDraw.DrawRay(ReferencePosition, ReferenceUp, ReferenceLength, Color.white);
            DebugDraw.DrawLine(ReferencePosition, TargetPosition, Color.yellow);

            return true;
        }

        private float RecordPenisAverage(float length)
        {
            if (_penisLengthAverages == null)
            {
                _penisLengthAverages = new float[PENIS_LENGTH_AVERAGES_COUNT];
                for (int i = 0; i < _penisLengthAverages.Length; i++)
                        _penisLengthAverages[i] = _penisLength;
            }
            _penisLengthAverages[_penisLengthAverageIndex] = length;
            _penisLengthAverageIndex++;
            if (_penisLengthAverageIndex >= _penisLengthAverages.Length)
                _penisLengthAverageIndex = 0;

            return (float)Math.Round((_penisLengthAverages.Sum() / (float)_penisLengthAverages.Length), 5);
        }

        private void FindMales()
        {
            var defaultMale = MaleChooser.val;
            var people = Controller.GetAtoms().Where(a => a.type == "Person");
            var maleUids = people
                .Where(a => a.GetComponentInChildren<DAZCharacterSelector>().gender == DAZCharacterSelector.Gender.Male)
                .Select(a => a.uid)
                .ToList();

            if (!maleUids.Contains(defaultMale))
                defaultMale = maleUids.FirstOrDefault(uid => uid == _maleAtom?.uid) ?? maleUids.FirstOrDefault() ?? "None";
            maleUids.Insert(0, "None");

            MaleChooser.choices = maleUids;
            MaleChooserCallback(defaultMale);
        }

        public override void StoreConfig(JSONNode config)
        {
            config.Store(MaleChooser);
            config.Store(MaleUsePenisFixedLengthReference);
            config.Store(MalePenisFixedLengthReference);

            base.StoreConfig(config);
        }

        public override void RestoreConfig(JSONNode config)
        {
            config.Restore(MaleChooser);
            config.Restore(MaleUsePenisFixedLengthReference);
            config.Restore(MalePenisFixedLengthReference);

            base.RestoreConfig(config);

            FindMales();
        }

        protected void MaleChooserCallback(string s)
        {
            _maleAtom = Controller.GetAtomByUid(s);
            MaleChooser.valNoCallback = _maleAtom == null ? "None" : s;
            _invalidAutoTargetUid = MaleChooser.val;
        }

        protected override void RefreshButtonCallback()
        {
            base.RefreshButtonCallback();
            FindMales();
        }
    }
}
